#!/bin/bash

# run as ./startvncjob.sh 1 8   # e.g. 1 node 8 hours
clear



if [ $# -eq 0 ]
  then
	echo ""    
     echo "Not enough arguments supplied, use e.g. to ask for 1 node and 8 hours: $0 1 8"
     exit 0
fi

echo "Please connect to VPN (anyconnect.coventry.ac.uk) before proceeding"

echo "It is also a good idea to check if you have VNC password on HPC (you can set it up at the end of this script when it will connect you to HPC)"

echo ""
echo ""


echo "Enter your HPC username:"

read username

ssh ${username}@pluto "sbatch -N$1 --exclusive -t $2:00:00 /share/apps/slurm/vnc.slurm; sleep 5; squeue -u ${username}"

echo ""
echo "Now establishing the tunnel to the target node..."
echo ""
echo "Enter the assigned node name, e.g. compute-0-1"

read node

port=$(( RANDOM % 100 ))
plutoport=$(( 5900 + port ))

echo " now connecting... you can start vnc viewer and connect to localhost:5901. Do not close this console!"

# Uncomment next line if you are on Mac and want to launch vnc viewer automatically
#open vnc://localhost:5901

printf "When you finished the VNC session, you can select 'Logout' from the main Pluto menu OR kill the VNC job from this console with 'scancel JOBID', where jobid can be found in the output of 'squeue -u ${username}'.\n \n If you never set up VNC password, you can do it now by running 'vncpasswd' in this console.\n"

echo "press Enter to start the SSH Tunnel"
read foo

ssh -t -L localhost:5901:localhost:$plutoport ${username}@pluto ssh -L $plutoport:localhost:5901 $node
